︠5820dc7f-6319-4d03-a3cd-ebc2997e5748s︠
version()
︡d73d808b-d632-45c3-b360-96ece99d1cbb︡{"html":"<div align='center'>SageMath version 7.5, Release Date: 2017-01-11</div>"}︡{"done":true}︡
︠3b6ad09f-75ef-4506-9182-4f32dc927668s︠
%typeset_mode True
n = 6
︡7c3b493d-bb86-48ec-89c2-fba96c9c4db7︡{"done":true}︡
︠2b9da14d-238f-4f2f-bbb2-916aa2a7b1bbs︠
Rn = Manifold(n, 'R^' + str(n), latex_name=r'\mathbb{R}^' + str(n), start_index=1)
print(Rn)
Rn
︡29e49109-14eb-4934-822d-b81b31085c3c︡{"stdout":"6-dimensional differentiable manifold R^6\n"}︡{"html":"<div align='center'>$\\displaystyle \\mathbb{R}^6$</div>"}︡{"done":true}︡
︠e9d76f3f-30a1-4ee5-a26c-49de7e1ca5bds︠
# The canonical global chart on R^n
E = Rn.chart(coordinates=' '.join('x' + str(i) for i in Rn.irange()))
print(E)
E
︡76806b0e-b9b0-4311-b113-40116b5447b2︡{"stdout":"Chart (R^6, (x1, x2, x3, x4, x5, x6))\n"}︡{"html":"<div align='center'>$\\displaystyle \\left(\\mathbb{R}^6,(x_{1}, x_{2}, x_{3}, x_{4}, x_{5}, x_{6})\\right)$</div>"}︡{"done":true}︡
︠d55e2606-5662-49e9-a9bc-74f9c1d5fb93s︠
# Define the open subset on R^n where we will have polar coordinates and restric the canonical chart
# we should actually exclude more in order to have diffeomorphism
U = Rn.open_subset('U', coord_def={E: [sum(map(lambda x: x**2, E[:])) > 0]})
print(U)
U
E_U = E.restrict(U)
print(E_U)
E_U
︡480b3506-ed35-4041-8da2-fe11516720bf︡{"stdout":"Open subset U of the 6-dimensional differentiable manifold R^6\n"}︡{"html":"<div align='center'>$\\displaystyle U$</div>"}︡{"stdout":"Chart (U, (x1, x2, x3, x4, x5, x6))\n"}︡{"html":"<div align='center'>$\\displaystyle \\left(U,(x_{1}, x_{2}, x_{3}, x_{4}, x_{5}, x_{6})\\right)$</div>"}︡{"done":true}︡
︠273bc4f8-a0f0-49bd-85b8-a0f47fa51997s︠
# Define another chart on U for the spherical coordinates
#P_U = U.chart(r"r:(0,+oo) ph:(0,2*pi):\phi " + r" ".join("th" + str(i+1) + r":(0,pi):\theta_" + str(i+1) for i in range(Rn.dim() - 2)))
P_U = U.chart(r"r:(0,+oo) " + r" ".join("th" + str(i) + r":(0,pi):\theta_" + str(i) for i in range(1, Rn.dim() - 1)) + r" th%d:(0,2*pi):\theta_%d" % (Rn.dim()-1, Rn.dim()-1))
print(P_U)
P_U
︡ef948c9a-8dc1-471a-933d-aef694e33962︡{"stdout":"Chart (U, (r, th1, th2, th3, th4, th5))\n"}︡{"html":"<div align='center'>$\\displaystyle \\left(U,(r, {\\theta_1}, {\\theta_2}, {\\theta_3}, {\\theta_4}, {\\theta_5})\\right)$</div>"}︡{"done":true}︡︡
︠7261d8a7-d674-4806-afcd-951da594801cs︠
P_U.coord_range()
︡6c2dd812-49a0-4c7c-ab5c-c36db29f09bf︡{"html":"<div align='center'>$\\displaystyle r :\\ \\left( 0 , +\\infty \\right) ;\\quad {\\theta_1} :\\ \\left( 0 , \\pi \\right) ;\\quad {\\theta_2} :\\ \\left( 0 , \\pi \\right) ;\\quad {\\theta_3} :\\ \\left( 0 , \\pi \\right) ;\\quad {\\theta_4} :\\ \\left( 0 , \\pi \\right) ;\\quad {\\theta_5} :\\ \\left( 0 , 2 \\, \\pi \\right)$</div>"}︡{"done":true}︡
︠ff5b1249-994f-4879-ac90-ef5fdde9cff6s︠
assumptions()
︡78088d50-de53-459c-869b-021e1749f57b︡{"stdout":"x1 is real\nx2 is real\nx3 is real\nx4 is real\nx5 is real\nx6 is real\nr is real\nth1 is real\nth2 is real\nth3 is real\nth4 is real\nth5 is real\n"}︡{"html":"<div align='center'>[$\\displaystyle r &gt; 0$, $\\displaystyle {\\theta_1} &gt; 0$, $\\displaystyle {\\theta_1} &lt; \\pi$, $\\displaystyle {\\theta_2} &gt; 0$, $\\displaystyle {\\theta_2} &lt; \\pi$, $\\displaystyle {\\theta_3} &gt; 0$, $\\displaystyle {\\theta_3} &lt; \\pi$, $\\displaystyle {\\theta_4} &gt; 0$, $\\displaystyle {\\theta_4} &lt; \\pi$, $\\displaystyle {\\theta_5} &gt; 0$, $\\displaystyle {\\theta_5} &lt; 2 \\, \\pi$]</div>"}︡{"done":true}︡
︠d8fbca5c-2213-4942-ba50-d27d462de702s︠
# Let's build the transition maps!
# First a helper function...

def p_to_e_x(i, P_U):
    # returns the ith coordinate of the transition function
    n = P_U.domain().dim()
    if i < n:
        return P_U[1]*prod(sin(P_U[j]) for j in range(2, i+1))*cos(P_U[i+1])
    else:
        return P_U[1]*prod(sin(P_U[j]) for j in range(2, n+1))

for i in Rn.irange():
    show(p_to_e_x(i, P_U))

mapping = [p_to_e_x(i, P_U) for i in Rn.irange()]

%time transit_P_to_E = P_U.transition_map(E_U, mapping)
transit_P_to_E.display()
︡d3b46d7e-7f4d-4cc3-ba27-da6d226d7db8︡{"html":"<div align='center'>$\\displaystyle r \\cos\\left({\\theta_1}\\right)$</div>"}︡{"html":"<div align='center'>$\\displaystyle r \\cos\\left({\\theta_2}\\right) \\sin\\left({\\theta_1}\\right)$</div>"}︡{"html":"<div align='center'>$\\displaystyle r \\cos\\left({\\theta_3}\\right) \\sin\\left({\\theta_1}\\right) \\sin\\left({\\theta_2}\\right)$</div>"}︡{"html":"<div align='center'>$\\displaystyle r \\cos\\left({\\theta_4}\\right) \\sin\\left({\\theta_1}\\right) \\sin\\left({\\theta_2}\\right) \\sin\\left({\\theta_3}\\right)$</div>"}︡{"html":"<div align='center'>$\\displaystyle r \\cos\\left({\\theta_5}\\right) \\sin\\left({\\theta_1}\\right) \\sin\\left({\\theta_2}\\right) \\sin\\left({\\theta_3}\\right) \\sin\\left({\\theta_4}\\right)$</div>"}︡{"html":"<div align='center'>$\\displaystyle r \\sin\\left({\\theta_1}\\right) \\sin\\left({\\theta_2}\\right) \\sin\\left({\\theta_3}\\right) \\sin\\left({\\theta_4}\\right) \\sin\\left({\\theta_5}\\right)$</div>"}︡{"stdout":"\nCPU time: 148.43 s, Wall time: 153.18 s"}︡{"stdout":"\n"}︡{"html":"<div align='center'>$\\displaystyle \\left\\{\\begin{array}{lcl} x_{1} &amp; = &amp; r \\cos\\left({\\theta_1}\\right) \\\\ x_{2} &amp; = &amp; r \\cos\\left({\\theta_2}\\right) \\sin\\left({\\theta_1}\\right) \\\\ x_{3} &amp; = &amp; r \\cos\\left({\\theta_3}\\right) \\sin\\left({\\theta_1}\\right) \\sin\\left({\\theta_2}\\right) \\\\ x_{4} &amp; = &amp; r \\cos\\left({\\theta_4}\\right) \\sin\\left({\\theta_1}\\right) \\sin\\left({\\theta_2}\\right) \\sin\\left({\\theta_3}\\right) \\\\ x_{5} &amp; = &amp; r \\cos\\left({\\theta_5}\\right) \\sin\\left({\\theta_1}\\right) \\sin\\left({\\theta_2}\\right) \\sin\\left({\\theta_3}\\right) \\sin\\left({\\theta_4}\\right) \\\\ x_{6} &amp; = &amp; r \\sin\\left({\\theta_1}\\right) \\sin\\left({\\theta_2}\\right) \\sin\\left({\\theta_3}\\right) \\sin\\left({\\theta_4}\\right) \\sin\\left({\\theta_5}\\right) \\end{array}\\right.$</div>"}︡{"done":true}︡
︠8b640521-40cf-45ce-904b-67797648c35cs︠
︡1db7bc55-d281-4682-a73e-b96a48e93acf︡{"done":true}︡









